#!/usr/local/bin/perl -w

%names = ();                    # hash of names
@raw = ();                      # raw words
$fn = "";                       # first name
$in = '';                       # temporary in
@keys = ();                     # temporary keys
@n = ();                        # temporary name
$search = '';                   # thing to search for

while (<>) {
    chomp;
    @raw = split(" ", $_);
    if ($#raw == 1) {  # regular case
        $names{$raw[1]} = $raw[0];
    } else {  # build a first name
        $fn = "";
        for ($i = 0; $i < $#raw; $i++) {
            $fn .= $raw[$i] . " ";
        }
        $names{$raw[$#raw]} = $fn;
    }
}

while () {
    print "\n1. Sort names by last name\n";
    print "2. Sort names by first name\n";
    print "3. Search for a name\n";
    print "4. Quit\n\n";
    print "Choose a number: ";

    if ($in eq '1') {           # sort and print by last name
        foreach $name (sort keys %names) {
            print "$name, $names{$name}\n";
        }

    } elsif ($in eq '2') {      # sort and print by first name
        @keys = sort { $names{$a} cmp $names{$b} } keys %names;
        foreach $name (@keys) {
            print "$names{$name} $name\n";
        }
    } elsif ($in eq '3') {      # find a name (1 or more)
        print "Search for what? ";
        chomp($search = <STDIN>);

        while (@n = each %names) {
            if (grep /$search/, @n) {
                $keys[++$#keys] = $n[0];
            }
        }

        if (@keys) {
            print "Names matched: \n";
            foreach $name (sort @keys) {
                print "   $names{$name} $name\n";
            }
        } else {
            print "None found.\n";
        }

        @keys = ();  # undefine @keys for next search
   } elsif ($in eq '4') {      # quit
      last;
   } else {
      print "Not a good answer.  1 to 4 please.\n";
   }
}

